︠00119555-f02c-442c-8f81-82825ff88995i︠
%html
<h2>Simulating Random Variables Using a Uniform Distribution</h2>
<p>As discussed briefly in the book (and in more detail in notes), we can use the built-in <strong>random</strong>&nbsp;function, available in most programming languages, to simulate other random variables as well. &nbsp;We will need to know the density (or some piece of information that gives us the density) of the random variable to be simulated.</p>
<p>First, let's take a look at the <strong>random</strong>&nbsp;function.</p>

︡88642fdb-2d38-40e1-a3bb-435251e258d0︡{"html": "<h2>Simulating Random Variables Using a Uniform Distribution</h2>\n<p>As discussed briefly in the book (and in more detail in notes), we can use the built-in <strong>random</strong>&nbsp;function, available in most programming languages, to simulate other random variables as well. &nbsp;We will need to know the density (or some piece of information that gives us the density) of the random variable to be simulated.</p>\n<p>First, let's take a look at the <strong>random</strong>&nbsp;function.</p>"}︡
︠bc8f3f4c-0215-4a51-8127-5c8a14b23c1e︠
random()
︡f6fc8c7a-3f6e-451d-be3a-caee2b1f7cee︡{"stdout": "0.37452349136492957"}︡
︠466f3615-d19d-439a-a01c-0d84fd6a05d0︠
[random() for i in range(8)]
︡cc9f070e-ca7d-42ef-b7f5-11fdb3692a4e︡{"stdout": "[0.76729971279762299, 0.84261613607162034, 0.34083321846329728, 0.47237033755796765, 0.22387522561551454, 0.18616466221686401, 0.86465531657256556, 0.027024983991109308]"}︡
︠593ff1bc-0aae-4753-92f7-2f5b2bd87d53i︠
%html
<p>The <strong>random</strong>&nbsp;function returns a pseudorandom sample from a Uniform(0,1) distribution. &nbsp;Let's use it to simulate some other random variables. &nbsp;Recall that the <em>idea</em>&nbsp;is that\[Y=F_Y^{-1}(U)\]where $Y$ is the new random variable, $U$ is the Uniform(0,1) random variable, and $F_Y$ is the distribution function for $Y$.</p>
<h3>Example 1:</h3>
<p>Suppose $Y$ is the Uniform(-2,2) random variable. &nbsp;Then\[F_Y(y)=\left\{\begin{array}{cc}0&amp;y&lt;-2\\ \frac{y+2}{4}&amp;-2\leq y\leq 2\\ 1&amp;y&gt;2\end{array}\right.\]We can invert this function algebraically:\[F_Y^{-1}(u)=\left\{\begin{array}{cc}-2&amp;u&lt;0\\ 4u-2&amp;0\leq u\leq 1\\ 2&amp;u&gt;1\end{array}\right.\]Thus our code will be pretty simple.</p>

︡1d7b70ad-43c0-4c73-b97f-00acb3918426︡{"html": "<p>The <strong>random</strong>&nbsp;function returns a pseudorandom sample from a Uniform(0,1) distribution. &nbsp;Let's use it to simulate some other random variables. &nbsp;Recall that the <em>idea</em>&nbsp;is that\\[Y=F_Y^{-1}(U)\\]where $Y$ is the new random variable, $U$ is the Uniform(0,1) random variable, and $F_Y$ is the distribution function for $Y$.</p>\n<h3>Example 1:</h3>\n<p>Suppose $Y$ is the Uniform(-2,2) random variable. &nbsp;Then\\[F_Y(y)=\\left\\{\\begin{array}{cc}0&amp;y&lt;-2\\\\ \\frac{y+2}{4}&amp;-2\\leq y\\leq 2\\\\ 1&amp;y&gt;2\\end{array}\\right.\\]We can invert this function algebraically:\\[F_Y^{-1}(u)=\\left\\{\\begin{array}{cc}-2&amp;u&lt;0\\\\ 4u-2&amp;0\\leq u\\leq 1\\\\ 2&amp;u&gt;1\\end{array}\\right.\\]Thus our code will be pretty simple.</p>"}︡
︠531f7055-9a1c-410a-a829-e24fcff13166︠
def r():
    return 4*random()-2
︡6279dc5a-3787-4ebe-a57a-36be1cc8be9f︡︡
︠05ae7b4c-15c0-4334-bb95-3b1887ed960di︠
%html
<p>Let's take a look at a sample of our random variable.</p>

︡13d2d3f2-fdc4-4f4f-b1db-bb15a981407b︡{"html": "<p>Let's take a look at a sample of our random variable.</p>"}︡
︠94777976-47ef-41f5-b3ef-24be3495d62e︠
[r() for i in range(20)]
︡cab3b8ca-38d5-4018-b6ed-056bcf047440︡{"stdout": "[-0.2348097236576332, 0.92668312999571434, -0.54716904118411902, 0.5021973051009021, -0.05856081673581981, -1.2683765526382111, 0.2780102469217729, -0.10584052339384176, -1.2265790149283315, 1.5571019849233942, 0.3671489553757854, 1.8478766924522292, 0.97559443201467744, -1.6312252404353784, -0.46962864632193346, 0.72800414743978781, 0.92995856437223212, 0.4894900756890519, 0.70774578093319018, 0.40200920324234746]"}︡
︠962961a2-2958-4acd-b729-ccc014e41cc0i︠
%html
<p>This seems to be working pretty well! &nbsp;Let's move on to our more complicated examples.</p>
<h3>Example 2:</h3>
<p>Suppose that $Y$ is the Normal(0,1) random variable. &nbsp;The density function is\[f_Y(y)=\frac{1}{\sqrt{2\pi}}\, e^{-y^2/2}\]and can be implemented as:</p>

︡acfb0b16-da39-469a-b07e-b9eef6f74ae3︡{"html": "<p>This seems to be working pretty well! &nbsp;Let's move on to our more complicated examples.</p>\n<h3>Example 2:</h3>\n<p>Suppose that $Y$ is the Normal(0,1) random variable. &nbsp;The density function is\\[f_Y(y)=\\frac{1}{\\sqrt{2\\pi}}\\, e^{-y^2/2}\\]and can be implemented as:</p>"}︡
︠2bf26997-02c0-4ec2-9f21-fd6446025288︠
def f(y):
    return float(1/sqrt(2.*pi)*exp(-y^2/2))
︡214e256b-5183-4780-bbfb-968044b71dd6︡︡
︠11649ec4-1b18-4185-9252-3c203b211eadi︠
%html
<p>We then tabulate the density and distribution functions:</p>

︡bf92cbdb-ebc9-4dc9-97f6-7f9c2c38757e︡{"html": "<p>We then tabulate the density and distribution functions:</p>"}︡
︠ac0a0ea6-282e-4569-a8e1-f5b847ce9dbc︠
h=0.01
y=[-6.0+h*i for i in range(12/h+1)]
fY=[f(Y) for Y in y]
FY=[0]
for z in fY[:-1]:
    FY.append(FY[-1]+z*h)
︡380cf4d7-4e10-458a-807d-e2c685f78c17︡︡
︠d7efd358-71e9-43e5-9ac5-2e2f0f580c95i︠
%html
<p>The first few values of FY are...</p>

︡5476388c-9746-4e3e-bd4a-12ae62938b96︡{"html": "<p>The first few values of FY are...</p>"}︡
︠302a3c96-7051-4284-bb22-a64cec9e6f26︠
FY[:10]
︡95f37c29-fb56-4b29-bdde-ff059f3bac88︡{"stdout": "[0, 6.07588284982329e-11, 1.25271547406350e-10, 1.93763235536208e-10, 2.66472033655209e-10, 3.43649875780914e-10, 4.25563259815706e-10, 5.12494059544508e-10, 6.04740380117335e-10, 7.02617459241747e-10]"}︡
︠db52b272-69c9-4422-b948-83b1ed6b6b4ai︠
%html
<p>Now we construct the code to draw a sample value from the normal distribution.</p>

︡e33e0515-7b7c-4a08-b8f4-84e8cc00390b︡{"html": "<p>Now we construct the code to draw a sample value from the normal distribution.</p>"}︡
︠19113e7b-952b-4bf2-a471-61ff41338609︠
def n():
    u=random()
    k=0
    while k+1<len(FY) and FY[k+1]<u: k+=1
    return y[k]
︡7f404e32-97d8-4eea-b104-e87d0d816aa0︡︡
︠69eb8c6e-b86b-4097-ada0-a4bf415f3248i︠
%html
<p>We can draw a few values and look at them.</p>

︡052c83c6-c66a-4bce-bc93-c0e508873aa0︡{"html": "<p>We can draw a few values and look at them.</p>"}︡
︠9a8eb7c5-0843-4caa-8dbb-5592df802f8d︠
[n() for i in range(20)]
︡0a9537bc-8da2-4e89-b5dd-6a1767068d73︡{"stdout": "[-0.110000000000000, 0.910000000000000, 2.16000000000000, 1.36000000000000, 0.360000000000000, 1.01000000000000, 0.960000000000000, 1.78000000000000, 1.49000000000000, 0.0300000000000002, 1.12000000000000, 0.220000000000000, -1.11000000000000, 1.15000000000000, 0.0899999999999999, -0.530000000000000, -0.190000000000000, 0.470000000000000, -2.03000000000000, 0.140000000000001]"}︡
︠f6da333f-f4f6-4d64-afc1-ed93dc3568abi︠
%html
<p>It is hard to say from this small sample whether the data is approximately normal. &nbsp;So, let's draw a much larger sample - N=5000 - and construct a frequency plot for (rounded) values.</p>

︡4deee63b-96f2-4dba-a575-5ba514c5211e︡{"html": "<p>It is hard to say from this small sample whether the data is approximately normal. &nbsp;So, let's draw a much larger sample - N=5000 - and construct a frequency plot for (rounded) values.</p>"}︡
︠8ef4ac73-82b6-4c8d-83c7-65e7429bfbff︠
data=[floor(10*n()) for i in range(5000)]
x=range(min(data),max(data)+1)
freq=[data.count(t) for t in x]
bar_chart(freq)
︡28fa8c7f-1f3d-47e6-b16f-2c30612d4329︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠3322c063-5c4a-415e-8ae5-8be6b395fba0i︠
%html
<p>This seems to be producing a sample with a distribution tolerably close to a normal distribution. &nbsp;If we needed to use this code in applications, we would want to (a) design it to be much faster, and (b) test it more rigorously.</p>
<h3>Example 3:</h3>
<p>Now let's consider a discrete random variable. &nbsp;We can define the density function through a simple list of probabilities.</p>

︡208389c6-2638-4bba-afc7-402af94ff390︡{"html": "<p>This seems to be producing a sample with a distribution tolerably close to a normal distribution. &nbsp;If we needed to use this code in applications, we would want to (a) design it to be much faster, and (b) test it more rigorously.</p>\n<h3>Example 3:</h3>\n<p>Now let's consider a discrete random variable. &nbsp;We can define the density function through a simple list of probabilities.</p>"}︡
︠dfdfe0c0-3536-4ad7-b274-d7cf91f9c93e︠
outcomes=['a','b','c','d','e']
p=[1/10,2/10,1/10,5/10,1/10]
︡7191680d-0e1a-4b38-983b-b3a32668282b︡︡
︠65f498a5-0a25-497c-970f-a07f8f383309i︠
%html
<p>(Note that this is truly a density function, since the probabilities sum to 1.)</p>

︡6de61288-7b53-496a-a369-4ad765c18bbb︡{"html": "<p>(Note that this is truly a density function, since the probabilities sum to 1.)</p>"}︡
︠34bb2e83-d709-4286-8e08-953293b227e1︠
sum(p)
︡cd57f092-824d-48f2-8f5b-f19c6a3b86f6︡{"stdout": "1"}︡
︠5e1b29c8-4ba8-4b7c-a281-bd9d3d22cdcdi︠
%html
<p>Construct the distribution:</p>

︡45b22be9-40a5-41e5-8693-3cdff56d8c78︡{"html": "<p>Construct the distribution:</p>"}︡
︠e8b7e8e0-e58b-4bc5-bee8-a7044da1c7c9︠
F=[0]
for y in p:
    F.append(F[-1]+y)
︡ffdc3b2e-1b9c-4ea6-a532-01dbc8deba72︡︡
︠0e3c5b6e-b1d9-4f64-94b9-3b8f1e651fe0i︠
%html
<p>This distribution function is then</p>

︡58c36df7-7afd-4eef-9d27-6dd89fc92ef4︡{"html": "<p>This distribution function is then</p>"}︡
︠534b0928-bda6-47f2-8849-af8c6f8192c6︠
F
︡90f80c11-1280-40b5-86f2-b09433673d37︡{"stdout": "[0, 1/10, 3/10, 2/5, 9/10, 1]"}︡
︠d723efc5-c4d9-4dbc-8846-dd2b2c5ddbfci︠
%html
<p>As for the normal random variable, we now define our discrete random variable with a simple loop.</p>

︡2d504007-9f38-42ae-a15c-5a01cb956e73︡{"html": "<p>As for the normal random variable, we now define our discrete random variable with a simple loop.</p>"}︡
︠04a1be56-6ba3-42f2-843b-29fbbefbf1a1︠
def d():
    u=random()
    k=0
    while k<len(F) and F[k]<u: k+=1
    return outcomes[k-1]
︡e7f12d44-2dd0-4d23-90d9-ebe4eda3feb1︡︡
︠52874b24-7e8b-4ee2-a708-f85c8ea9afeei︠
%html
<p>We can look at a small sample...</p>

︡2914d2db-ab2c-4b65-9b67-3214d5581f2b︡{"html": "<p>We can look at a small sample...</p>"}︡
︠2a959a0c-f0ba-40cf-8dc3-6deef5a9953a︠
[d() for i in range(20)]
︡17102412-3b0d-4905-850b-e66b0094f680︡{"stdout": "['d', 'b', 'd', 'b', 'd', 'd', 'e', 'c', 'b', 'b', 'b', 'e', 'd', 'd', 'c', 'd', 'd', 'b', 'c', 'b']"}︡
︠b00162db-1bd8-447b-a984-3082549a34a6i︠
%html
<p>...and we can look at a large sample to see whether we have (approximately) the correct distribution.</p>

︡12a8093c-3589-44f6-b086-550c4f5b99c0︡{"html": "<p>...and we can look at a large sample to see whether we have (approximately) the correct distribution.</p>"}︡
︠befe901a-9d9f-4680-8ea5-53622ff940e9︠
N=10000
data=[d() for i in range(N)]
freq=[data.count(t)/float(N) for t in outcomes]
bar_chart(freq)
︡d0d0b612-678a-4d55-a998-95d176f75e8d︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠446f0448-2b85-4e68-ac00-fd7a878f503ai︠
%html
<p>Compare the sampled results,</p>

︡9e240033-63a9-4261-86ea-e9e78bba58ec︡{"html": "<p>Compare the sampled results,</p>"}︡
︠0fa7822f-224d-45d9-862c-e9a93a0701e5︠
freq
︡874b73d0-0b34-4255-a099-c8cd3634f111︡{"stdout": "[0.1018, 0.20130000000000001, 0.097799999999999998, 0.50090000000000001, 0.098199999999999996]"}︡
︠80b71a81-0f25-4df3-a320-d7b5b01b64eci︠
%html
<p>to the given probability density:</p>

︡5dbce315-e38a-4cfa-9ba3-b00345628bb2︡{"html": "<p>to the given probability density:</p>"}︡
︠4bb627d9-036f-4f91-90e6-08a6766bd69b︠
p
︡c82c66d3-6544-49a2-a4d6-6d744465bed2︡{"stdout": "[1/10, 1/5, 1/10, 1/2, 1/10]"}︡
︠e5768db9-3421-4b08-9f87-397178d4daeai︠
%html
<p>We are not far off at all!</p>
<p>It is worth noting that SAGE (and the Python language) incorporate some nice tools for manipulating discrete random variables. &nbsp;In this case, the&nbsp;<strong>choice</strong>&nbsp;function works particularly well.</p>

︡c9758d14-fa92-4121-ba6b-7906a8a4a7dd︡{"html": "<p>We are not far off at all!</p>\n<p>It is worth noting that SAGE (and the Python language) incorporate some nice tools for manipulating discrete random variables. &nbsp;In this case, the&nbsp;<strong>choice</strong>&nbsp;function works particularly well.</p>"}︡
︠12846612-ba44-465a-8508-eec0ce8a2938︠
new_outcomes=['a']+2*['b']+['c']+5*['d']+['e']
new_outcomes
︡90c4de38-07e2-4c24-ac79-7e2eb37069f1︡{"stdout": "['a', 'b', 'b', 'c', 'd', 'd', 'd', 'd', 'd', 'e']"}︡
︠60facd2c-9fa5-4253-a124-cfd7b47bcf8e︠
def new_d():
    return choice(new_outcomes)
︡64ca615d-116e-4742-9648-82089675961d︡︡
︠907b95b0-ab20-4912-9f35-829b43a7965c︠
N=10000
new_data=[new_d() for i in range(N)]
new_freq=[new_data.count(t)/float(N) for t in outcomes]
bar_chart(new_freq)
︡f4703665-3462-4ab9-8e47-0d027ed1b92c︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠5807ca86-6aa9-42f2-9c60-9a69aee73318︠
new_freq
︡74b73354-4293-481c-9fd3-4c0e507541eb︡{"stdout": "[0.1023, 0.20380000000000001, 0.097699999999999995, 0.49640000000000001, 0.0998]"}︡
︠9b0816e3-1723-49ed-87e6-f6cf91eb7694i︠
%html
<p>Thus we can avoid computing our distribution and coding the loop that steps through and looks at values.</p>

︡5c91bce6-0cc0-44d0-89aa-22bfdd7fb7fa︡{"html": "<p>Thus we can avoid computing our distribution and coding the loop that steps through and looks at values.</p>"}︡
︠6b28ca4a-e7f3-47df-8e9d-4d3e49fb8889i︠
%html
<h2>Section 6.4: The Method of Transformations</h2>
<p>Suppose that $Y$ is a given random variable with known density function $f_Y$, and define $U=h(Y)$, where $h$ is a function. &nbsp;Then we would like to find the density $f_U$ of $U$. &nbsp;On page 316 of our text, the authors outline the method of transformations. &nbsp;While this method can be useful, it suffers from one flaw: we must be able to algebraically solve $u=h(y)$ for $y$ in order to find a formula for the inverse function $h^{-1}$.</p>
<p>For example, suppose that $Y$ is the uniform random variable Uniform(1,2), and suppose that $h$ is the function defined by\[h(y)=y\cdot\ln(y)\ \ \ y&gt;0\]Then, plotting this function on the support of $Y$ indicates that it satisfies the monotonicity requirements of the method of transformations:</p>

︡1c22cc6e-8503-4c62-afc7-93efb87ef3a2︡{"html": "<h2>Section 6.4: The Method of Transformations</h2>\n<p>Suppose that $Y$ is a given random variable with known density function $f_Y$, and define $U=h(Y)$, where $h$ is a function. &nbsp;Then we would like to find the density $f_U$ of $U$. &nbsp;On page 316 of our text, the authors outline the method of transformations. &nbsp;While this method can be useful, it suffers from one flaw: we must be able to algebraically solve $u=h(y)$ for $y$ in order to find a formula for the inverse function $h^{-1}$.</p>\n<p>For example, suppose that $Y$ is the uniform random variable Uniform(1,2), and suppose that $h$ is the function defined by\\[h(y)=y\\cdot\\ln(y)\\ \\ \\ y&gt;0\\]Then, plotting this function on the support of $Y$ indicates that it satisfies the monotonicity requirements of the method of transformations:</p>"}︡
︠a23142fc-2018-41de-aae3-0c31d4281b98︠
y=var('y')
plot1=plot(y*ln(y),(y,1,2))
show(plot1)
︡5de30266-4c69-4875-b4f8-a3b039e566dc︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠16ac75b1-e962-421d-a7c6-e8b36dba5a6ei︠
%html
<p>In order to apply the method of transformations to find $f_U$, we need to solve\[u=y\cdot\ln(y)\]for $y$. &nbsp;This is, algebraically speaking, an ugly problem.</p>
<p>Instead of approaching this symbolically, we can try to approach it numerically. &nbsp;The method we demonstrate here is fairly elementary, and based on evenly spaced samples of the function $h$.</p>
<p>So, let's begin by tabulating $h$ on the support of $Y$.</p>

︡1e5b8723-7556-4782-87be-45170e8fbd55︡{"html": "<p>In order to apply the method of transformations to find $f_U$, we need to solve\\[u=y\\cdot\\ln(y)\\]for $y$. &nbsp;This is, algebraically speaking, an ugly problem.</p>\n<p>Instead of approaching this symbolically, we can try to approach it numerically. &nbsp;The method we demonstrate here is fairly elementary, and based on evenly spaced samples of the function $h$.</p>\n<p>So, let's begin by tabulating $h$ on the support of $Y$.</p>"}︡
︠43066676-7e02-4e28-8c48-f475f2281417︠
dy=0.01
support=[1+i*dy for i in range(100)]
u=[float(t*ln(t)) for t in support]
inverse_rate=[abs((support[i+1]-support[i])/(u[i+1]-u[i])) for i in range(len(support)-1)]
︡318f2a02-670a-429c-a1c8-84dd1ecad9ba︡︡
︠ac1f5bf5-0c84-412e-a3d8-e1a53591720c︠
h_inverse=line([(u[i],support[i]) for i in range(len(u))])
h_inverse_rate=line([(u[i],inverse_rate[i]) for i in range(len(inverse_rate))],color='red')
show(h_inverse+h_inverse_rate)
︡21c7dbd5-886a-4492-b0da-5ff2ee6421b8︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠1c75208b-ce3f-4eb4-bd63-8ba6c839654ei︠
%html
<p>We can now use these tables to construct the density function for $U$.</p>

︡72186f1d-afe2-4b77-8bb5-844ab017157f︡{"html": "<p>We can now use these tables to construct the density function for $U$.</p>"}︡
︠1d58d43e-9312-4c46-b48e-0e45a0314e83︠
def f_U(x):
    nn=[abs(x-t) for t in u]
    m=min(nn)
    k=nn.index(m)
    return inverse_rate[k]
︡622d889a-4706-4d0e-8c16-e971e1ef205e︡︡
︠2ec174dc-a90c-4bcc-9ad9-f12537598008︠
test=line([(u[i],f_U(u[i])) for i in range(len(u)-1)])
︡6a6c5b6f-917d-47b4-a08d-02ba03dff241︡︡
︠3cf456b8-abff-412f-beb7-076efbca3181︠
test.show()
︡64136b5b-eebd-4c49-b59d-984967ab94f5︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠db67d392-4aae-4c46-9a6b-fab84b09155bi︠
%html
<p>This is a fairly elementary example (in particular, the fact that the density of $Y$ is constant on its support makes things quite a bit simpler). &nbsp;However, it indicates how more complex examples can be approached numerically, using the straightforward approach of function tabulation together with a difference quotient estimate of the derivative.</p>

︡3483453f-538c-4d85-bdb6-bb6e0dc345fe︡{"html": "<p>This is a fairly elementary example (in particular, the fact that the density of $Y$ is constant on its support makes things quite a bit simpler). &nbsp;However, it indicates how more complex examples can be approached numerically, using the straightforward approach of function tabulation together with a difference quotient estimate of the derivative.</p>"}︡
